'**************************************************************************
'*	-- setup.mst --
'*
'*	Power Window T64V Application Setup script
'*
'*	Copyright (C) 1996 CANOPUS Co.,Ltd. All rights reserved.
'**************************************************************************

'$INCLUDE 'setupapi.inc'
'$INCLUDE 'msdetect.inc' 
'$INCLUDE 'msregdb.inc'

''Dialog ID's
CONST	WELCOMEV		=200
CONST	WELCOMEVUS		=201
CONST	ASKQUITV		=400
CONST	ASKQUITVUS		=401
CONST	OPTIONSV		=600
CONST	OPTIONSVUS		=601
CONST	OPTIONSVM		=602
CONST	OPTIONSVMUS		=603
CONST	PWBOARD			=700
CONST	PWBOARDUS		=701
CONST	DESTPATHW95		=1001
CONST	DESTPATHUSW95	=1003
CONST	EXITSUCCESSW95	=1101
CONST	EXITSUCCESSUSW95=1103
CONST	EXITQUIT		=1200
CONST	EXITQUITUS		=1201
CONST	EXITFAILURE		=1300
CONST	EXITFAILUREUS	=1301
CONST	EXITCHECK		=1400
CONST	EXITCHECKUS		=1401
CONST	DESTINSTALL		=1500
CONST	DESTINSTALLUS	=1501
CONST	BADPATHW95		=2001
CONST	BADPATHUSW95	=2003
CONST	POWERERROR		=2100
CONST	POWERERRORUS	=2101
CONST	DISKERROR		=2200
CONST	DISKERRORUS		=2201

''Defalut Setting
CONST	LOGO 	=1
CONST	SHOWMAX	=3
CONST	TRUE	=1
CONST	FALSE	=0

''CustInst list
CONST 	TOTALKBOX	=5
CONST 	CHECKBOX1	=1
CONST 	CHECKBOX2	=2
CONST 	CHECKBOX3	=3
CONST 	CHECKBOX4	=4
CONST 	CHECKBOX5	=5

'' Users Area
GLOBAL	DEST$				'' Default Dir
GLOBAL	WINDRIVE$			'' Windows Dir
GLOBAL	GROUP$				'' Group Name
GLOBAL	CUIDLL$				'' User DLL File Name
GLOBAL	CHECKSTATES$		'' Check Box Data
GLOBAL	JPMODE AS INTEGER 	'' Japanese / English Mode
GLOBAL	WINMODE AS INTEGER 	'' Windows Version
GLOBAL	OPBOARD AS INTEGER 	'' Option Board
GLOBAL	MPEGFLG AS INTEGER 	'' MPEG Board  TRUE:HARD MPEG FALSE:SOFT MPEG
GLOBAL	VIDEOFLG AS INTEGER '' Video Board TRUE:YES       FALSE:NO
GLOBAL	PWFLG AS INTEGER	'' FALSE:Power Window T64V,MPEG Option Board  TRUE:Power Windows T64VMP

''CustInst list symbol names
DECLARE SUB 		Install
DECLARE FUNCTION	MakePath (szDir$, szFile$) AS STRING
DECLARE	SUB 		IniSetAndBakup (szFile$, szSec$, szKey$, szVal$, szSecOp$)
DECLARE	SUB 		IniSetAndStandBakup (szFile$, szSec$, szKey$, szVal$, szSecOp$)
DECLARE FUNCTION	CheckPowerWindow LIB "mscuistf.dll" () AS INTEGER
DECLARE FUNCTION	GetPowerWindowDir LIB "mscuistf.dll" () AS INTEGER
DECLARE FUNCTION	GetWindowsVer LIB "mscuistf.dll" () AS INTEGER
DECLARE FUNCTION	ExitWindowsExec  LIB "User" (Exec$, Param$) AS INTEGER
DECLARE FUNCTION	GetMetrics LIB "mscuistf.dll" () AS INTEGER


'
' #[ INIT ]
'
INIT:
	CUIDLL$ = "mscuistf.dll"			''Custom user interface dll

	WINMODE = GetWindowsVer()
	JPMODE = GetMetrics()

	SetWindowSize SHOWMAX
	SetBitmap CUIDLL$, LOGO
	SetTitle "Power Window T64V Application Setup"

	szInf$ = GetSymbolValue("STF_SRCINFPATH")
	IF szInf$ = "" THEN
		szInf$ = GetSymbolValue("STF_CWDDIR") + "setup.inf"
	END IF
	ReadInfFile szInf$

'	PWFLG = FALSE		'' PWT64V,MPEG VIDEO Board
	PWFLG = TRUE		'' PWT64VMP

	IF WINMODE = FALSE THEN
		IF JPMODE <> 0 THEN
			i% = DoMsgBox("Windows 95 p̃AvP[V̂߁Åɂ̓CXg[ł܂B", "Power Window T64V Application Setup", MB_OK+MB_TASKMODAL+MB_ICONHAND)
		ELSE
			i% = DoMsgBox("Please install Windows 95 before installing Power Window T64V Application.", "Power Window T64V Application Setup", MB_OK+MB_TASKMODAL+MB_ICONHAND)
		END IF
		END
	END IF

	DEST$ = ""
	WINDRIVE$ = GetWindowsDir()
	i% = GetPowerWindowDir()
	IF i% = TRUE THEN
		DEST$ = GetSymbolValue("PwDirOut")
	END IF
	IF DEST$ = "" THEN
		DEST$ = MID$(WINDRIVE$, 1, 1) + ":\PWAPP"
	END IF
	
	i% = CheckPowerWindow()
	IF i% = FALSE THEN 
		IF JPMODE <> 0 THEN
			dlg% = POWERERROR
		ELSE
			dlg% = POWERERRORUS
		END IF
		sz$ = UIStartDlg(CUIDLL$, dlg%, "FInfoDlgProc", 0, "")
		END
	END IF

WELCOME:
	IF JPMODE <> 0 THEN
		dlg% = WELCOMEV
	ELSE
		dlg% = WELCOMEVUS
	END IF
	sz$ = UIStartDlg(CUIDLL$, dlg%, "FInfoDlgProc", 0, "")
	IF sz$ = "CONTINUE" THEN
		UIPop 1
	ELSE
	   	GOSUB ASKQUITJMP
		GOTO WELCOME
	END IF

BOARDCHECKSTART:
	IF PWFLG = TRUE THEN
		MPEGFLG=TRUE		'' Hard MPEG Driver
		VIDEOFLG%=FALSE		'' Video Chip NO
		GOTO CHECKCUTSTART
	END IF		
	RemoveSymbol "CheckTool"
	AddListItem "CheckTool", "OFF"

BOARDCHECKLOOP:
	IF JPMODE <> 0 THEN
		dlg% = PWBOARD
	ELSE
		dlg% = PWBOARDUS
	END IF
	sz$ = UIStartDlg(CUIDLL$, dlg%, "FCheck0DlgProc", 0, "")
	IF sz$ = "CONTINUE" THEN
		IF GetListItem("CheckTool", 1) = "OFF" THEN
			MPEGFLG=FALSE		'' Soft MPEG Driver
			VIDEOFLG%=FALSE		'' Video Chip NO
		ELSE
			MPEGFLG=TRUE		'' Hard MPEG Driver
			VIDEOFLG%=TRUE		'' Video Chip OK
		END IF
		UIPop 1
		GOTO CHECKCUTSTART
	ELSE
		GOSUB ASKQUITJMP
		GOTO BOARDCHECKLOOP
	END IF

CHECKCUTSTART:
	CHECKSTATES$ = "CheckItemsIn"
	RemoveSymbol CHECKSTATES$
	RemoveSymbol "OptionsGreyed"
	IF JPMODE <> 0 THEN
		AddListItem CHECKSTATES$, "ON"		'' Release Note
	ELSE
		AddListItem CHECKSTATES$, "OFF"
		AddListItem "OptionsGreyed", "1"
	END IF

	AddListItem CHECKSTATES$, "ON"			'' Power Cinema
	IF MPEGFLG% = TRUE THEN
		AddListItem CHECKSTATES$, "ON"		'' MPEG Driver
	ELSE
		AddListItem CHECKSTATES$, "ON"
	END IF
	IF VIDEOFLG% = TRUE THEN
		AddListItem CHECKSTATES$, "ON"		'' Video Viewer
		AddListItem CHECKSTATES$, "ON"		'' TV Tuner
	ELSE
		AddListItem CHECKSTATES$, "OFF"
		AddListItem "OptionsGreyed", "4"
		AddListItem CHECKSTATES$, "OFF"
		AddListItem "OptionsGreyed", "5"
	END IF

CHECKCUTLOOP:
	IF PWFLG = FALSE THEN		'' PWT64V,MPEG VIDEO Baord
		IF JPMODE <> 0 THEN
			dlg% = OPTIONSV
		ELSE
			dlg% = OPTIONSVUS
		END IF
	ELSE
		IF JPMODE <> 0 THEN
			dlg% = OPTIONSVM
		ELSE
			dlg% = OPTIONSVMUS
		END IF
	END IF
	sz$ = UIStartDlg(CUIDLL$, dlg%, "FCheckDlgProc", 0, "")
	IF sz$ = "CONTINUE" THEN
		push% = 0
		CHECKSTATES$ = "CheckItemsOut"
		FOR i% = 1 TO TOTALKBOX STEP 1
			IF GetListItem(CHECKSTATES$, i%) = "ON" THEN
				push% = 1
			END IF
		NEXT i%
		IF push% = 0 THEN
			IF JPMODE <> 0 THEN
				dlg% = EXITCHECK
			ELSE
				dlg% = EXITCHECKUS
			END IF
			sz$ = UIStartDlg(CUIDLL$, dlg%, "FInfoDlgProc", 0, "")
			UIPop 1
			GOTO CHECKCUTLOOP
		END IF
		UIPop 1
		GOTO GETPATH
	ELSEIF sz$ = "BACK" THEN
		UIPop 1
		IF PWFLG = FALSE THEN
			GOTO BOARDCHECKLOOP
		ELSE
			GOTO WELCOME
		END IF
	ELSE
		GOSUB ASKQUITJMP
		GOTO CHECKCUTLOOP
	END IF

GETPATH:
	SetSymbolValue "EditTextIn", DEST$
	SetSymbolValue "EditFocus", "END"
GETPATHL1:
	IF JPMODE <> 0 THEN
		dlg% = DESTPATHW95
	ELSE
		dlg% = DESTPATHUSW95
	END IF
	sz$ = UIStartDlg(CUIDLL$, dlg%, "FEditDlgProc", 0, "")
	DEST$ = GetSymbolValue("EditTextOut")
	IF sz$ = "CONTINUE" THEN
		IF IsDirWritable(DEST$) = 0 THEN
			GOSUB INPUTPATH
			GOTO GETPATHL1
		END IF
		UIPop 1
	ELSEIF sz$ = "REACTIVATE" THEN
		GOTO GETPATHL1
	ELSEIF sz$ = "BACK" THEN
		UIPop 1
		GOTO CHECKCUTLOOP
	ELSE
		GOSUB ASKQUITJMP
		GOTO GETPATHL1
	END IF

INST:
	IF JPMODE <> 0 THEN
		dlg% = DESTINSTALL
	ELSE
		dlg% = DESTINSTALLUS
	END IF
	sz$ = UIStartDlg(CUIDLL$, dlg%, "FInfoDlgProc", 0, "")
	IF sz$ = "CONTINUE" THEN
		UIPop 1
	ELSEIF sz$ = "BACK" THEN
		UIPop 1
		GOTO GETPATH
	ELSE
		GOSUB ASKQUITJMP
		GOTO INST
	END IF

	Install

QUIT:
	ON ERROR GOTO ERRQUIT

	IF ERR = 0 THEN
		IF JPMODE <> 0 THEN
			dlg% = EXITSUCCESSW95
		ELSE
			dlg% = EXITSUCCESSUSW95
		END IF
	ELSEIF ERR = STFQUIT THEN
		IF JPMODE <> 0 THEN
			dlg% = EXITQUIT
		ELSE
			dlg% = EXITQUITUS
		END IF
	ELSE
		IF JPMODE <> 0 THEN
			dlg% = EXITFAILURE
		ELSE
			dlg% = EXITFAILUREUS
		END IF
	END IF
QUITL1:
	sz$ = UIStartDlg(CUIDLL$, dlg%, "FInfoDlgProc", 0, "")
	IF sz$ = "CONTINUE" THEN
	    UIPop 1
		END
	END IF

RESET:
	new% = ExitExecRestart()
	Exe$ = WINDRIVE$ + "\_msrstrt.exe"
	Empty$ = ""
RESTART1:
	IF new% = 0 THEN
		IF JPMODE <> 0 THEN
			i% = DoMsgBox("Windows ċNł܂B̃AvP[ViMS-DOSējIĂB", "ZbgAbv G[", MB_OK+MB_TASKMODAL+MB_ICONHAND)
		ELSE
			i% = DoMsgBox("The Setup program cannot restart Windows. Please terminate all other applications and MS-DOS Prompt.", "Setup Error", MB_OK+MB_TASKMODAL+MB_ICONHAND)
		END IF
	END IF
	I% = ExitWindowsExec (Exe$, Empty$)
	IF I% = 0 THEN
		GOTO RESET
	ELSE
		END
	END IF
	END

ERRQUIT:
	IF JPMODE <> 0 THEN
		i% = DoMsgBox("ZbgAbvfBXN̓eĂ܂BeNjJT|[g܂ŘAĂB", "ZbgAbv G[", MB_OK+MB_TASKMODAL+MB_ICONHAND)
	ELSE
		i% = DoMsgBox("This Setup disk is destroyed. Please contact our Technical Support.", "Setup Error", MB_OK+MB_TASKMODAL+MB_ICONHAND)
	END IF
	END

INPUTPATH:
	IF JPMODE <> 0 THEN
		dlg% = BADPATHW95
	ELSE
		dlg% = BADPATHUSW95
	END IF
	sz$ = UIStartDlg(CUIDLL$, dlg%, "FInfo0DlgProc", 0, "")
	IF sz$ = "REACTIVATE" THEN
		GOTO INPUTPATH
	END IF
	UIPop 1
	RETURN

ASKQUITJMP:
	IF JPMODE <> 0 THEN
		dlg% = ASKQUITV
	ELSE
		dlg% = ASKQUITVUS
	END IF
	sz$ = UIStartDlg(CUIDLL$, dlg%, "FQuitDlgProc", 0, "")
	IF sz$ = "EXIT" THEN
		UIPopAll
		ERROR STFQUIT
	ELSEIF sz$ = "REACTIVATE" THEN
		GOTO ASKQUITJMP
	ELSE
		UIPop 1
	END IF
	RETURN

'*****************************************************
'** e:
'**	 	CXg[̍
'** :
'**	 	Ȃ
'** ߂l:
'**	 	Ȃ
'*****************************************************
SUB Install STATIC

	SrcDir$ = GetSymbolValue("STF_SRCDIR")

	'' a:\english\setup.exeNꍇA\[XfBNgPKwグ
	'' `FbNiƂāASETUP.INF ̗LŔ
	l& = GetSizeOfFile(SrcDir$ + "SETUP.INF")
	IF l& = 0 THEN
		ist% = 1
		istold% = 1
		istop% = 1
		WHILE ( istop% )
			ied% = INSTR(ist%, SrcDir$, "\")
			IF ied% = 0 THEN
				istop% = 0
			ELSE
				istold% = ist%
				ist% = ied% + 1
			END IF
		WEND
		IF istold% <> 1 THEN
			SrcDir$ = Mid$(SrcDir$, 1, (istold% - 1))
		END IF
	END IF

	WinSysDir$ = GetWindowsSysDir()
	CreateDir DEST$, cmoNone
	CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "DIR", DEST$, cmoOverwrite
	CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "InstallApplication", "SECTION", "PowerWindowApp", cmoOverwrite

''t@CRs[Xg̓o^
	CHECKSTATES$ = "CheckItemsOut"
	IF GetListItem(CHECKSTATES$, 1) = "ON" THEN
		AddSectionFilesToCopyList "OPTION1", SrcDir$, DEST$
		CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE0", MakePath(DEST$,"README.TXT"), cmoOverwrite
	END IF

	IF GetListItem(CHECKSTATES$, 2) = "ON" THEN
		AddSectionFilesToCopyList "OPTION2", SrcDir$, DEST$
		AddSectionFilesToCopyList "OPTSYS2", SrcDir$, WinSysDir$

		CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE1", MakePath(DEST$,"PWCINE95.EXE"), cmoOverwrite
		CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE2", MakePath(DEST$,"PWCINE95.DOC"), cmoOverwrite
		CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE3", MakePath(DEST$,"VCDMCI95.DLL"), cmoOverwrite
		CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE4", MakePath(DEST$,"CINEMA95.DLL"), cmoOverwrite
		CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE5", MakePath(WinSysDir$,"PWCSETUP.DLL"), cmoOverwrite
		CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE6", MakePath(WinSysDir$,"PWJPEG.DRV"), cmoOverwrite
	END IF

	IF GetListItem(CHECKSTATES$, 3) = "ON" THEN
		IF MPEGFLG = FALSE THEN		'' Soft MPEG Driver
			AddSectionFilesToCopyList "OPTSYS3", SrcDir$, WinSysDir$
			AddSectionFilesToCopyList "OPTWIN3", SrcDir$, WINDRIVE$
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE9", MakePath(WINDRIVE$,"SOFTPEG.INI"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE10", MakePath(WinSysDir$,"SOFTPEGC.DLL"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE11", MakePath(WinSysDir$,"CCMPEGW.DLL"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE12", MakePath(WinSysDir$,"CCMPEG.DLL"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE13", MakePath(WinSysDir$,"SOFTPEG.DRV"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE14", MakePath(WinSysDir$,"SOFTPEG3.DLL"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE15", MakePath(WinSysDir$,"SOFTPEGC.DLL"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE16", MakePath(WinSysDir$,"CD16.DRV"), cmoOverwrite
		ELSE							'' Hard MPEG Driver
			AddSectionFilesToCopyList "OPTION3", SrcDir$, DEST$
			AddSectionFilesToCopyList "OPTSYS3", SrcDir$, WinSysDir$
			AddSectionFilesToCopyList "OPTSYS30", SrcDir$, WinSysDir$
			AddSectionFilesToCopyList "OPTSYS31", SrcDir$, WinSysDir$
			AddSectionFilesToCopyList "OPTWIN3", SrcDir$, WINDRIVE$
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE7", MakePath(DEST$,"CDALLOC.EXE"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE8", MakePath(DEST$,"MPEGC.EXE"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE9", MakePath(WINDRIVE$,"SOFTPEG.INI"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE10", MakePath(WinSysDir$,"SOFTPEGC.DLL"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE11", MakePath(WinSysDir$,"CCMPEGW.DLL"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE12", MakePath(WinSysDir$,"CCMPEG.DLL"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE13", MakePath(WinSysDir$,"SOFTPEG.DRV"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE14", MakePath(WinSysDir$,"SOFTPEG3.DLL"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE15", MakePath(WinSysDir$,"SOFTPEGC.DLL"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE16", MakePath(WinSysDir$,"CD16.DRV"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE17", MakePath(WinSysDir$,"PWTVMPEG.DRV"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE18", MakePath(WinSysDir$,"PWMPG.DLL"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE19", MakePath(WinSysDir$,"PWVDE.DLL"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE20", MakePath(WinSysDir$,"PWADE.DLL"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE21", MakePath(WinSysDir$,"PWMX2.DLL"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE22", MakePath(WinSysDir$,"PWMX16.DLL"), cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE23", MakePath(WinSysDir$,"PWMX32.DLL"), cmoOverwrite
		END IF
	END IF

	IF GetListItem(CHECKSTATES$, 4) = "ON" THEN
		AddSectionFilesToCopyList "OPTSYS4", SrcDir$, WinSysDir$
		AddSectionFilesToCopyList "OPTSYS31", SrcDir$, WinSysDir$
		AddSectionFilesToCopyList "OPTION4", SrcDir$, DEST$
		CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE24", MakePath(DEST$,"PWVVIEW.EXE"), cmoOverwrite
		CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE25", MakePath(DEST$,"PWVVIEW.HLP"), cmoOverwrite
		CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE26", MakePath(WinSysDir$,"PWTVCAP.DRV"), cmoOverwrite
		CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE27", MakePath(WinSysDir$,"PWDIALOG.DLL"), cmoOverwrite
		CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE28", MakePath(WinSysDir$,"PWMX16.DLL"), cmoOverwrite
		CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE29", MakePath(WinSysDir$,"PWMX32.DLL"), cmoOverwrite
	END IF

	IF GetListItem(CHECKSTATES$, 5) = "ON" THEN
		AddSectionFilesToCopyList "OPTSYS5", SrcDir$, WinSysDir$
		AddSectionFilesToCopyList "OPTION5", SrcDir$, DEST$
		CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE30", MakePath(DEST$,"PWTVTUN.EXE"), cmoOverwrite
		CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE31", MakePath(WinSysDir$,"PWTVTUN.DLL"), cmoOverwrite
	END IF

	AddSectionFilesToCopyList "OPTIONA", SrcDir$, DEST$
	CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "FILE32", MakePath(DEST$,"PWAPUIST.EXE"), cmoOverwrite

''t@CRs[
	SizeReq& = GetCopyListCost ("","", "")
	IF SizeReq& <> 0 THEN
		IF JPMODE <> 0 THEN
			dlg% = DISKERROR
		ELSE
			dlg% = DISKERRORUS
		END IF
		sz$ = UIStartDlg(CUIDLL$, dlg%, "FInfoDlgProc", 0, "")
		END
	END IF
	SetRestartDir WINDRIVE$
	CopyFilesInCopyList

''hmht@C̓o^
	IF GetListItem(CHECKSTATES$, 2) = "ON" THEN
		RemoveInisection WINDRIVE$ + "CANOPUS.INI", "Power Cinema 95" , cmoVital
		IniSetAndBakup WINDRIVE$ + "SYSTEM.INI", "DRIVERS", "VIDC.MJPG", "PWJPEG.DRV", "SYS"
		CreateIniKeyValue WINDRIVE$ + "CANOPUS.INI", "SETUP"  , "SETUPDLL" , "PWCSETUP.DLL", cmoOverwrite
		CreateIniKeyValue WINDRIVE$ + "CONTROL.INI", "DRIVERS.DESC", "PWJPEG.DRV", "CANOPUS Power Window Motion JPEG Decompressor", cmoOverwrite
	END IF

	IF GetListItem(CHECKSTATES$, 3) = "ON" THEN
		IF MPEGFLG = FALSE THEN		'' Soft MPEG Driver
			IniSetAndBakup WINDRIVE$ + "SYSTEM.INI", "MCI", "MPEGVIDEO", "SOFTPEG.DRV", "SYS"
			IniSetAndBakup WINDRIVE$ + "SYSTEM.INI", "MCI", "MPEGVIDEOCD", "SOFTPEG.DRV CDI", "SYS"
			CreateIniKeyValue WINDRIVE$ + "CONTROL.INI", "DRIVERS.DESC", "SOFTPEG.DRV", "[MCI] CompCore SoftPEG (TM) MPEG Driver", cmoOverwrite
		ELSE							'' Hard MPEG Driver
			szLoad$ = GetIniKeyString(INDRIVE$ + "Win.ini", "WINDOWS", "LOAD")
			szWrite$ = ""
			ist% = 1
			istop% = 1
			WHILE ( istop% )
				ied% = INSTR(ist%, szLoad$, " ")
				IF ied% = 0 THEN
					istop% = 0
					ied% = LEN(szLoad$) + 1
				END IF
				szBuff$ = Mid$(szLoad$, ist%, (ied% - ist%))
				ret% = InStr(szBuff$, "CDALLOC.EXE")
				IF ret% = 0 THEN
					szWrite$ = szWrite$ + szBuff$ + " "
				END IF
				ist% = ied% + 1
			WEND
			szWrite$ = szWrite$ + MakePath(DEST$,"CDALLOC.EXE")
			CreateIniKeyValue WINDRIVE$ + "WIN.INI", "WINDOWS", "LOAD", szWrite$, cmoOverwrite

			IniSetAndBakup WINDRIVE$ + "SYSTEM.INI", "MCI", "MPEGCDI", "PWTVMPEG.DRV", "SYS"
			IniSetAndBakup WINDRIVE$ + "SYSTEM.INI", "MCI", "MPEGVIDEO", "PWTVMPEG.DRV", "SYS"
			IniSetAndBakup WINDRIVE$ + "SYSTEM.INI", "MCI", "MPEGVIDEOCD", "SOFTPEG.DRV CDI", "SYS"
			CreateIniKeyValue WINDRIVE$ + "CONTROL.INI", "DRIVERS.DESC", "PWTVMPEG.DRV", "[MCI] CANOPUS Power Window MPEG Driver", cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "CONTROL.INI", "DRIVERS.DESC", "SOFTPEG.DRV", "[MCI] CompCore SoftPEG (TM) MPEG Driver", cmoOverwrite
		END IF

		CreateIniKeyValue WINDRIVE$ + "WIN.INI", "MCI EXTENSIONS", "MPG", "MPEGVIDEO", cmoOverwrite
		CreateIniKeyValue WINDRIVE$ + "WIN.INI", "MCI EXTENSIONS", "VID", "MPEGVIDEO", cmoOverwrite
		CreateIniKeyValue WINDRIVE$ + "WIN.INI", "MCI EXTENSIONS", "DAT", "MPEGVIDEO", cmoOverwrite
		CreateIniKeyValue WINDRIVE$ + "WIN.INI", "MCI EXTENSIONS", "MPA", "MPEGVIDEO", cmoOverwrite
		CreateIniKeyValue WINDRIVE$ + "WIN.INI", "MCI EXTENSIONS", "MPV", "MPEGVIDEO", cmoOverwrite

		RemoveIniKey  WINDRIVE$ + "SYSTEM.INI", "MCI", "CCMPEG"		, cmoNone
		RemoveIniKey  WINDRIVE$ + "SYSTEM.INI", "MCI", "CCMPEGCDI"	, cmoNone
		RemoveIniKey  WINDRIVE$ + "MPLAYER.INI", "DEVICES", "CCMPEG", cmoNone
		RemoveIniKey  WINDRIVE$ + "MPLAYER.INI", "DEVICES", "CCMPEGCDI"	, cmoNone
		RemoveIniKey  WINDRIVE$ + "MPLAYER.INI", "OPTIONS", "CCMPEG"	, cmoNone
		RemoveIniKey  WINDRIVE$ + "MPLAYER.INI", "OPTIONS", "CCMPEGCDI"	, cmoNone

		CreateRegKeyValue ".mpg", "mplayer"
	END IF

	IF GetListItem(CHECKSTATES$, 4) = "ON" THEN
		RemoveInisection WINDRIVE$ + "CANOPUS.INI", "Video Viewer" , cmoVital
		RemoveInisection WINDRIVE$ + "CANOPUS.INI", "T64VCapture" , cmoVital
		IniSetAndStandBakup WINDRIVE$ + "SYSTEM.INI", "DRIVERS", "MSVideo", "PWTVCAP.DRV", "SYS"
		CreateIniKeyValue WINDRIVE$ + "CONTROL.INI", "DRIVERS.DESC", "PWTVCAP.DRV", "Power Window T64V Video Capture Driver", cmoOverwrite
	END IF

''O[vo^
	IF JPMODE <> 0 THEN
		GROUP$ = "PowerWindow ع"
	ELSE
		GROUP$ = "PowerWindow Application"
	END IF
	CreateProgmanGroup GROUP$, "", cmoNone
	ShowProgmanGroup   GROUP$,  1, cmoNone
	CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "GROUP", GROUP$, cmoOverwrite

	IF GetListItem(CHECKSTATES$, 1) = "ON" THEN
		IF JPMODE <> 0 THEN
			szIcon$ = "ذɰ"
		ELSE
			szIcon$ = "Release Note"
		END IF
		CreateProgmanItem  GROUP$, szIcon$ , "NOTEPAD.EXE "+MakePath(DEST$,"README.TXT") , "", cmoOverwrite
		CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "ICON0", szIcon$, cmoOverwrite
	END IF

	IF GetListItem(CHECKSTATES$, 2) = "ON" THEN
		CreateProgmanItem GROUP$, "PowerCinema 95", MakePath(DEST$,"PWCINE95.EXE") , "", cmoOverwrite
		CreateProgmanItem GROUP$, "PowerCinema 95 Manual", MakePath(DEST$,"PWCINE95.DOC")  , "", cmoOverwrite
		CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "ICON1", "PowerCinema 95", cmoOverwrite
		CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "ICON2", "PowerCinema 95 Manual", cmoOverwrite
	END IF

	IF GetListItem(CHECKSTATES$, 3) = "ON" THEN
		IF MPEGFLG = TRUE THEN		'' Hard MPEG Driver
			CreateProgmanItem  GROUP$, "MPEG Mapper" , MakePath(DEST$,"MPEGC.EXE"), "", cmoOverwrite
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "ICON3", "MPEG Mapper", cmoOverwrite
		END IF
	END IF

	IF GetListItem(CHECKSTATES$, 4) = "ON" THEN
		CreateProgmanItem  GROUP$, "Video Viewer" , MakePath(DEST$,"PWVVIEW.EXE"), "", cmoOverwrite
		CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "ICON4", "Video Viewer", cmoOverwrite
	END IF

	IF GetListItem(CHECKSTATES$, 5) = "ON" THEN
		CreateProgmanItem  GROUP$, "TV Tuner" , MakePath(DEST$,"PWTVTUN.EXE"), "", cmoOverwrite
		CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "ICON5", "TV Tuner", cmoOverwrite
	END IF

	IF JPMODE <> 0 THEN
		szIcon$ = "ݲݽİ"
	ELSE
		szIcon$ = "Uninstaller"
	END IF
	CreateProgmanItem  GROUP$, szIcon$ , MakePath(DEST$,"PWAPUIST.EXE"), "", cmoOverwrite
	CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", "ICON6", szIcon$, cmoOverwrite
END SUB


'*****************************************************
'** e:
'**	 	tpX̍\̂ɕϊ
'** :
'**	 	szDir$  - tpXfBNg
'**	 	szFile$ - t@C܂̓fBNg
'** ߂l:	
'**		pX
'*****************************************************
FUNCTION MakePath (szDir$, szFile$) STATIC AS STRING
	IF szDir$ = "" THEN
		MakePath = szFile$
	ELSEIF szFile$ = "" THEN
		MakePath = szDir$
	ELSEIF MID$(szDir$, LEN(szDir$), 1) = "\" THEN
		MakePath = szDir$ + szFile$
	ELSE
		MakePath = szDir$ + "\" + szFile$
	END IF
END FUNCTION


'***************************************************************
'** e:
'**	 	Inieۊ
'**	 	o^΁AȂB
'** :
'**	 	szFile$ - tpXt@C
'**	 	szSec$  - ZNV
'**	 	szKey$  - L[
'**	 	szVal$  - l
'**	 	szSecOp$- fBNg
'** ߂l:	
'**		pX
'***************************************************************
SUB IniSetAndBakup (szFile$, szSec$, szKey$, szVal$, szSecOp$) STATIC

	szLoad$ = ""
	szLoadBak$ = ""

	szLoadBak$ = GetIniKeyString(szFile$, szSec$, szKey$)

	szLoad$ = GetIniKeyString(WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", szSecOp$ + szKey$)
	IF (szLoad$ = "") OR (szLoad$ <> szLoadBak$) THEN 
		IF (szLoadBak$ <> szVal$) THEN
			CreateIniKeyValue WINDRIVE$ + "UNPWCINE.INI", "PowerWindowApp", szSecOp$ + szKey$, szLoadBak$, cmoOverwrite
		END IF
	END IF
	CreateIniKeyValue szFile$, szSec$, szKey$, szVal$, cmoOverwrite

END SUB


'***************************************************************
'** e:
'**	 	Inieۊ
'**	 	o^΁AL[eɖo^ԍ(1`9)ǉĕۊǂ
'** :
'**	 	szFile$ - tpXt@C
'**	 	szSec$  - ZNV
'**	 	szKey$  - L[
'**	 	szVal$  - l
'**	 	szSecOp$- fBNg
'** ߂l:	
'**		pX
'***************************************************************
SUB IniSetAndStandBakup (szFile$, szSec$, szKey$, szVal$, szSecOp$) STATIC

	szLoad$ = ""
	szLoadBak$ = ""
	szLoadBak$ = GetIniKeyString(szFile$, szSec$, szKey$)

	IF szLoadBak$ = szVal$ THEN 
		EXIT SUB
	END IF

	FOR i% = 1 TO 9 STEP 1
		Number$ = MID$(STR$(i%), 2, 1)
		szLoad$ = GetIniKeyString(szFile$, szSec$, szKey$+Number$)
		IF (szLoad$ = szLoadBak$) OR (szLoad$ = szVal$) THEN
			RemoveIniKey  szFile$, szSec$, szKey$+Number$, cmoNone
		END IF
	NEXT i%

	n% = 1
	FOR i% = 1 TO 9 STEP 1
		Number$ = MID$(STR$(i%), 2, 1)
		szLoad$ = GetIniKeyString(szFile$, szSec$, szKey$+Number$)
		IF (szLoad$ <> "") OR (szLoadBak$ <> "") THEN 
			Number$ = MID$(STR$(n%), 2, 1)
			IF szLoadBak$ <> "" THEN
				CreateIniKeyValue szFile$, szSec$, szKey$+Number$, szLoadBak$, cmoOverwrite
				n% = n% + 1
			END IF
			szLoadBak$ = szLoad$
		END IF
	NEXT i%
	
	CreateIniKeyValue szFile$, szSec$, szKey$, szVal$, cmoOverwrite

END SUB
